claw::math::ordered_set< K, Comp > Class Template Reference

A class to manage sets of ordered items. More...

`#include <ordered_set.hpp>`

Inheritance diagram for claw::math::ordered_set< K, Comp >:

## Public Types

typedef super::const_iterator | const_iterator
| The type of the iterator used to access non modifiable values.
typedef super::value_type | value_type
| The type of the values in the set.
typedef super::referent_type | referent_type
| The type passed to the template.
typedef super::const_reference | const_reference
| The type of a const reference on the values.
Public Types inherited from claw::avl< K, Comp >
typedef K | value_type
| The type of the values in the tree.
typedef K | key_type
| The type of the keys in the tree.
typedef K | referent_type
| The type passed to the template.
typedef Comp | key_less
| The comparator to use to compare the keys.
typedef const K & | const_reference
| The type of a const reference on the values.
typedef impl_type::avl_const_iterator | const_iterator
| The type of the iterator on the values of the tree.

## Public Member Functions

ordered_set & | operator*= (const ordered_set &that)
ordered_set & | operator+= (const ordered_set &that)
ordered_set & | operator-= (const ordered_set &that)
ordered_set & | operator/= (const ordered_set &that)
bool | operator> (const ordered_set &that) const
bool | operator>= (const ordered_set &that) const
bool | operator< (const ordered_set &that) const
bool | operator<= (const ordered_set &that) const
ordered_set & | intersection (const ordered_set &that)
ordered_set & | join (const ordered_set &that)
ordered_set & | difference (const ordered_set &that)
ordered_set & | symetric_difference (const ordered_set &that)
bool | contains (const ordered_set &that) const
bool | strictly_contains (const ordered_set &that) const
Public Member Functions inherited from claw::avl< K, Comp >
| avl (const avl< K, Comp > &that)
template<typename InputIterator>
| avl (InputIterator first, InputIterator last)
void | insert (const K &key)
template<typename InputIterator>
void | insert (InputIterator first, InputIterator last)
void | erase (const K &key)
void | clear ()
unsigned int | size () const
bool | empty () const
const_iterator | begin () const
const_iterator | end () const
const_iterator | find (const K &key) const
const_iterator | find_nearest_greater (const K &key) const
const_iterator | find_nearest_lower (const K &key) const
const_iterator | lower_bound () const
const_iterator | upper_bound () const
avl< K, Comp > & | operator= (const avl< K, Comp > &that)
bool | operator== (const avl< K, Comp > &that) const
bool | operator!= (const avl< K, Comp > &that) const
bool | operator< (const avl< K, Comp > &that) const
bool | operator> (const avl< K, Comp > &that) const
bool | operator<= (const avl< K, Comp > &that) const
bool | operator>= (const avl< K, Comp > &that) const

## Detailed Description

template<class K, class Comp = std::less<K>>
class claw::math::ordered_set< K, Comp >

A class to manage sets of ordered items.

Author
  Julien Jorge

Definition at line 44 of file ordered_set.hpp.

## Member Typedef Documentation

## const_iterator

template<class K, class Comp = std::less<K>>

typedef super::const_iterator claw::math::ordered_set< K, Comp >::const_iterator

The type of the iterator used to access non modifiable values.

Definition at line 54 of file ordered_set.hpp.

## const_reference

template<class K, class Comp = std::less<K>>

typedef super::const_reference claw::math::ordered_set< K, Comp >::const_reference

The type of a const reference on the values.

Definition at line 63 of file ordered_set.hpp.

## referent_type

template<class K, class Comp = std::less<K>>

typedef super::referent_type claw::math::ordered_set< K, Comp >::referent_type

The type passed to the template.

Definition at line 60 of file ordered_set.hpp.

## value_type

template<class K, class Comp = std::less<K>>

typedef super::value_type claw::math::ordered_set< K, Comp >::value_type

The type of the values in the set.

Definition at line 57 of file ordered_set.hpp.

The documentation for this class was generated from the following file:

- ordered_set.hpp